#!/usr/bin/env python2.5
#
# json dbus bridge examples
#
# Copyright (c) 2010 by Michael Olbrich <m.olbrich@pengutronix.de>
#
# To the extent possible under law, Pengutronix e.K. has waived all copyright
# and related or neighboring rights to JSON-DBus-Bridge Demo Code.
#


import gobject

import dbus
import dbus.service
import dbus.mainloop.glib


class Service(dbus.service.Object):
	def __init__(self):
		busname = dbus.service.BusName("com.pengutronix.jdb.Calculator", dbus.SessionBus())
		dbus.service.Object.__init__(self, None, "/", busname)


	@dbus.service.method("com.pengutronix.jdb.Calculator",
		in_signature='ii', out_signature='i')
	def Add( self, a, b):
		return a + b

	@dbus.service.method("com.pengutronix.jdb.Calculator",
		in_signature='ai', out_signature='i')
	def AddAll(self, array):
		sum = 0
		for i in array:
			sum += i
		return sum

	@dbus.service.method("com.pengutronix.jdb.Calculator",
		in_signature='ii', out_signature='i')
	def Sub(self, a, b):
		return a - b

	@dbus.service.method("com.pengutronix.jdb.Calculator",
		in_signature='ii', out_signature='i')
	def Multiply(self, a, b):
		return a * b

	@dbus.service.method("com.pengutronix.jdb.Calculator",
		in_signature='ii', out_signature='i',
		async_callbacks = ("value", "error"))
	def Divide(self, a, b, value, error):
		if b == 0:
			error("division by zero")
		else:
			value(a/b)

dbus.mainloop.glib.DBusGMainLoop(set_as_default=True)

object = Service()

mainloop = gobject.MainLoop()
mainloop.run()

