
#include <QtCore/QCoreApplication>
#include <QtDBus/QtDBus>

#include "service.h"

int main(int argc, char *argv[])
{
	QCoreApplication app(argc, argv);

	if (!QDBusConnection::sessionBus().isConnected()) {
		fprintf(stderr, "Cannot connect to the D-Bus session bus.\n"
				"To start it, run:\n"
				"\teval `dbus-launch --auto-syntax`\n");
		return 1;
	}

	if (!QDBusConnection::sessionBus().registerService("com.pengutronix.jdb.systeminfo")) {
		fprintf(stderr, "%s\n",
				qPrintable(QDBusConnection::sessionBus().lastError().message()));
		exit(1);
	}

	QObject o;
	SystemInfo systemInfo(&o);
	if (!QDBusConnection::sessionBus().registerObject("/", &o)) {
		fprintf(stderr, "%s\n",
				qPrintable(QDBusConnection::sessionBus().lastError().message()));
		exit(1);
	}
	app.exec();

	return 0;
}

